--- old/usr/src/cmd/fm/modules/common/fabric-xlate/fx_subr.c	Fri Dec 30 20:20:56 2016
+++ new/usr/src/cmd/fm/modules/common/fabric-xlate/fx_subr.c	Fri Dec 30 20:20:56 2016
@@ -21,7 +21,9 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2016 Jason King
  */
+
 #include <strings.h>
 #include <fm/topo_hc.h>
 #include <sys/fm/util.h>
@@ -29,6 +31,7 @@
 #include <libxml/parser.h>
 #include <libxml/xpathInternals.h>
 #include <libxml/tree.h>
+#include <sys/debug.h>
 
 #include "fabric-xlate.h"
 
@@ -184,14 +187,17 @@
 {
 	fab_erpt_tbl_t	*erpt_tbl, *entry;
 	nvlist_t	*erpt;
+	uintptr_t	addr;
 	uint32_t	reg;
 
 	erpt_tbl = tbl->erpt_tbl;
+	addr = (uintptr_t)data + tbl->reg_offset;
+
 	if (tbl->reg_size == 16) {
-		reg = (uint32_t)*((uint16_t *)
-		    ((uint32_t)data + tbl->reg_offset));
+		reg = (uint32_t)*((uint16_t *)addr);
 	} else {
-		reg = *((uint32_t *)((uint32_t)data + tbl->reg_offset));
+		ASSERT3U(tbl->reg_size, ==, 32);
+		reg = *((uint32_t *)addr);
 	}
 
 	for (entry = erpt_tbl; entry->err_class; entry++) {
